// $Id: Login.java,v 1.25 2007-02-22 11:01:44+09 naito Exp $

package jp.ac.nagoya_u.math.servlet_sample.servlet ;

import java.io.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;
import jp.mynu.cas.client.*;

/**
 * Handles logins for the Central Authentication Service.
 */
public class Login extends HttpServlet {

    //*********************************************************************
    // SET URL of myself to CAS_SERVICE_URL
    private String CAS_SERVICE_URL ;
    private String CAS_LOGIN_URL ;
    private ServletContext app;
    private String loginForm ;

  //*********************************************************************
  // Initialization 

  public void init(ServletConfig config) throws ServletException {
    // retrieve the context and the caches
    app = config.getServletContext();
    CAS_SERVICE_URL = app.getInitParameter("jp.ac.nagoya_u.math.servlet_sample.casServiceURL") ;
    CAS_LOGIN_URL   = app.getInitParameter("jp.ac.nagoya_u.math.servlet_sample.casLoginURL") ;
    loginForm       = app.getInitParameter("jp.ac.nagoya_u.math.servlet_sample.loginForm") ;
  }


  //*********************************************************************
  // Request handling

  synchronized public void doPost(HttpServletRequest request, HttpServletResponse response)
      throws ServletException, IOException {
      perform(request, response) ;
      return ;
  }

  synchronized public void doGet(HttpServletRequest request, HttpServletResponse response)
      throws ServletException, IOException {
      perform(request, response) ;
      return ;
  }

  synchronized private void perform(HttpServletRequest request, HttpServletResponse response)
      throws ServletException, IOException {
      String	userid      = null ;
      String	fullname    = null ;

      //************* initial setting *************//
      Locale lo = new Locale("ja", "JP") ;
      response.setHeader("Pragma", "no-cache");
      response.setHeader("Cache-Control","no-cache");
      response.setDateHeader("Expires",-1);
      response.setContentType("text/html; charset=UTF-8") ;
      response.setLocale(lo) ;
      //************* END of initial setting ******//

      //*********** Perform CAS Client ************//
      CasClient cas = new CasClient(CAS_SERVICE_URL, CAS_LOGIN_URL) ;
      if (!cas.casPerform(request, response)) return ;
      Map r = cas.getResult() ;
      String    xmlResponse = cas.getResponse() ;
      //*********** End of Perform CAS Client ****//

      request.setAttribute("agent", request.getHeader("USER-AGENT")) ;
      if (r != null) {
	  request.setAttribute("userid", r.get("uid")) ;
	  request.setAttribute("nagoyaunivid", r.get("nagoyaunivid")) ;
	  request.setAttribute("mynuid", r.get("mynuid")) ;
	  request.setAttribute("cellermail", r.get("registkeitaimailaddress")) ;
	  request.setAttribute("res", r.toString()) ;
	  request.setAttribute("mail", r.get("registmailaddress")) ;
	  request.setAttribute("fullname", r.get("fullname")) ;
	  request.setAttribute("sn", r.get("sn")) ;
	  request.setAttribute("response", xmlResponse) ;
      }
      app.getRequestDispatcher(loginForm).forward(request, response) ;
      return ;
  }
}
